import { h } from '@stencil/core';
import { MDCRipple } from '@material/ripple';
import { fetchEnsName, watchAccount } from '@wagmi/core';
import state from '../../stores/wallet';
import truncateEthAddress from '../../utils/wallet';
export class NKConnectWalletButton {
  constructor() {
    this.ripple = null;
    this.isConnected = undefined;
    this.address = undefined;
    this.ensName = undefined;
  }
  componentWillLoad() {
    this.disconnect = watchAccount(async (account) => {
      this.isConnected = account.isConnected;
      this.address = account.address;
      if (account.isConnected) {
        this.ensName = await fetchEnsName({ address: account.address });
      }
    });
  }
  disconnectedCallback() {
    this.disconnect();
  }
  componentDidLoad() {
    this.ripple = new MDCRipple(this.button);
  }
  render() {
    return (h("div", { part: "wallet-btn-container", class: "mdc-touch-target-wrapper" }, h("button", { part: "wallet-btn", onClick: () => state.modal.openModal(), ref: (el) => (this.button = el), class: "mdc-button mdc-button--raised" }, h("span", { class: "mdc-button__ripple" }), h("span", { class: "mdc-button__touch" }), h("span", { class: "mdc-button__label" }, this.isConnected ? (this.ensName ? (this.ensName) : (truncateEthAddress(this.address))) : (h("slot", null))))));
  }
  static get is() { return "nk-connect-wallet-button"; }
  static get encapsulation() { return "shadow"; }
  static get originalStyleUrls() {
    return {
      "$": ["nk-connect-wallet-button.scss"]
    };
  }
  static get styleUrls() {
    return {
      "$": ["nk-connect-wallet-button.css"]
    };
  }
  static get states() {
    return {
      "isConnected": {},
      "address": {},
      "ensName": {}
    };
  }
}
//# sourceMappingURL=nk-connect-wallet-button.js.map
